------------------------------------------------------------------------------
--  Thin Ada95 binding to OCI (Oracle Call Interface)                    --
--  Copyright (C) 2000-2002 Dmitriy Anisimkov.                              --
--  License agreement and authors contact information are in file oci.ads   --
------------------------------------------------------------------------------

--  $Id$

package OCI.Thick.Date is

   function To_String (From : OCIDate; Format : String) 
        return String;

   subtype OCIDate is Lib.OCIDate;

   function SysDate return OCIDate;
        
   Init_OCIDate : constant OCIDate;

private

   Init_OCIDate : constant OCIDate := (
      OCIDateYYYY => 0, -- gregorian year; range is -4712 <= year <= 9999
      OCIDateMM   => 1, -- month; range is 1 <= month < 12
      OCIDateDD   => 1, -- day; range is 1 <= day <= 31
      OCIDateTime => (
         OCITimeHH => 0, -- hours; range is 0 <= hours <=23
         OCITimeMI => 0, -- minutes; range is 0 <= minutes <= 59
         OCITimeSS => 0) -- seconds; range is 0 <= seconds <= 59
     );    

   
end OCI.Thick.Date;