------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information could be found in oci.ads  --
------------------------------------------------------------------------------
with OCI.Thick.OCIHandle_Var,
     OCI.Thick.Statements;
package OCI.Thick.String_Var is

   use Statements;

   use OCI.Thick.OCIHandle_Var;

   type Variable is new Var_Type(SQLT_VST) with null record;
      
   procedure Initialize(Object : in out Variable);
   procedure Finalize  (Object : in out Variable);

   procedure Resize(Var : in out Variable; Length : Natural);
   procedure Allocator (Value : in out Var_Type'Class; Size : Natural);

   procedure Set_Value(Var : in out Variable; Value : String);
   function Get_Value(Var : Variable) return String;
   function Value(Var : Variable) return String renames Get_Value;
      
   procedure Define(Stmt : Statement; Value : in out Variable; Position : Positive);
      
--   procedure Bind(Stmt : Statement; Value : in out Variable; Name : String);
--   procedure Bind(Stmt : Statement; Value : in out Variable; Position : Positive);

end OCI.Thick.String_Var;