with OCI.Thick.Connections;
with OCI.Thick.Statements;
with OCI.Thick.Parameters;
with Text_IO;
with OCI.Lib;
with OCI.Thick.Strings;
with Ada.Strings.Fixed;
with Interfaces.C;
with Ada.Exceptions;
with GNAT.Traceback.Symbolic;
procedure dyn_def is
  use Text_IO;
  use OCI.Thick;
  use OCI.Thick.Connections;
  use OCI.Thick.Statements;
  use Interfaces.C;
  use OCI.Thick.Strings;
  use Ada.Strings.Fixed;
  
  Connect : Connection := Logon ("scott/tiger");
  Sel : Statement := Prepare (Connect, 
   "select empno ,ENAME ,hiredate from emp");
  

begin

   Execute (Sel);

   declare
      use OCI.Thick.Parameters;
      Params : Parameter_Array := Get_Parameters (Sel);
      Result : array (Params'Range) of Var_Type;
   begin
      for i in Params'Range loop
         Text_IO.Put (NAME (Params (i)));
         Text_IO.Put (Typecode'Image (Type_Code (Params (i))));
         Text_IO.Put (Type_Name (Params (i)));
         Text_IO.Put (Natural'Image (Data_Size (Params (i))));
         Text_IO.Put (Integer'Image (PRECISION (Params (i))));
         Text_IO.Put (Integer'Image (SCALE (Params(i))));
         Text_IO.Put (Boolean'Image (IS_NULL (Params (i))));
         Text_IO.Put_Line (SCHEMA_NAME (Params(i)));
         Define (Sel, Result(i), i);
      end loop;

      Put_Line ("Fetch");

      while Fetch(Sel) loop
         for i in Result'Range loop
            Text_IO.Put (", ");
            if IS_Null (Result(i)) then
               Text_IO.Put ("(null)");
            else
               Text_IO.Put (Value (Result(i)));
            end if;
         end loop;
         Text_IO.New_Line;
      end loop;

   end;
  
exception
   when E : others =>
      Text_IO.Put_Line(Ada.Exceptions.Exception_Information(E));
      Text_IO.Put_Line("----------");
      Text_IO.Put_Line(GNAT.Traceback.Symbolic.Symbolic_Traceback(E));
end dyn_def;