with
   Text_IO,
   Ada.Integer_Text_IO,
   Ada.Long_Float_Text_IO,
   Ada.Strings.Unbounded,
   Ada.Exceptions,
   Oci.Thick,
   OCI.Thick.Integer_Var,
   OCI.Thick.OCIDate_Var,
   OCI.Thick.Long_Float_Var,
   OCI.Thick.OCINumber_Var,
   OCI.Thick.String_Var,
   OCI.Thick.String_Bounded,
   OCI.Thick.Servers,
   OCI.Thick.Connections,
   OCI.Thick.Statements,
   OCI.Thick.Parameters,
   OCI.Thick.Number_Functions,
   OCI.Thick.Debug_Allocation,
   OCI.Environments,
   OCI.Thick.Strings;
with Ada.Exceptions;
with GNAT.Traceback.Symbolic;
procedure Test is
   use Text_IO, Oci.Thick;

   use 
      Ada.Integer_Text_IO,
      Ada.Long_Float_Text_IO,
      Ada.Strings.Unbounded,
      Long_Float_Var,
      Integer_Var,
      String_Bounded,
      OCIDate_Var,
      OCINumber_Var,
      String_Var,
      Connections,
      Servers,
      Statements,
      Parameters,
      Strings,
      Number_Functions;
      
   procedure Main is
      Strv : Strings.Variable;
      strb : String_Bounded.Variable (64);
      Int : Integer_Var.Variable;
      Flt : Long_Float_Var.Variable;
      Numb : OCINumber_Var.Variable;
      Date  : OCIDate_Var.Variable;
      Param : Parameter;
      Stmt : Statement;
      Connect : Connection;
      DB : Server := Attach ("");
      onumb1,onumb2 : OCINumber;
      NULL_descr : array (boolean) of String(1..8) := (false => "NOT NULL",TRUE => "    NULL");
   begin
      loop
      Connect := Logon (DB, "scott", "tiger");
      Put_Line ("Main");
      Put_Line ("Connected");
      put_line (Server_Version(Connect));
      
      Execute (Connect, "alter session set nls_date_format='YYYY-MM-DD HH24:MI:SS'");
      
      Stmt := Prepare(Connect, "select object_name,"&
          "timestamp, OBJECT_ID,"&
          "sysdate-created, sysdate-Last_ddl_Time, Last_ddl_Time"&Ascii.Lf&
          "from user_objects where object_id>:id"&Ascii.Lf&
          "and object_id< :id+10000000 and /*object_type = :objtype and */ object_name <> :objtype");
      declare
         names : VStrings := Bind_Names (Stmt);
      begin
         Put_Line("---------");
         for i in names'Range loop
           Put_Line(To_String(Names(i)));
         end loop; 
      end;    
      Bind(Stmt,Strb,"objtype");
      Set_Value(strb, "TABLE");
      Bind(Stmt, int, 1);
      Set_Value(int, 2);
      
      Execute (Stmt);

      declare
         Columns : Parameter_Array := Get_Parameters (Stmt);
      begin
         for i in Columns'Range loop
            Set_Col (01); Put (Name (Columns (i)));
            Set_Col (25); Put (Typecode'Image (Type_Code (Columns (i))));
            Set_Col (38); Put (Type_Name (Columns(i)));
            Set_Col (40); Put (Integer'Image (Data_Size (Columns (i))));
            Set_Col (45); Put (Integer'Image (Precision (Columns (i))));
            Set_Col (50); Put (Integer'Image (Scale (Columns (i))));
            Set_Col (55); Put (NULL_Descr (Is_Null (Columns (i))));
            Set_Col (65); Put (Schema_Name (Columns (i)));
         end loop;
--        Param := Columns(1);
      end;

      Define(Stmt,Strv,1);
      Define(Stmt,strb,2);
      Define(Stmt,Int,3);
      Define(Stmt,Flt,4);
      Define(Stmt,Numb,5);
      Define(Stmt,Date,6);

--      Set_Value(Strv,(1..230=> ' '));
      while Fetch(Stmt) loop
         Set_Col(1);  Put(Get_Value(Strv) & ',');
         Set_Col(16); Put(Get_Value(Strb));
         Set_Col(35); Put(Get_Value(Int),Width=>6);
         Set_Col(42); Put(Get_Value(Flt),Aft => 3,Exp=>0);
         Set_Col(50); Put(To_String(Get_Value(Numb),"FM999990.99999"));
         Set_Col(60); Put(To_String(Get_Value(Date),"DD Mon RRRR HH24:MI:SS"));
      end loop;
      
      Set_Col (1);
      
      Stmt := Prepare (Connect, "begin :result := (sysdate - :client_time)*60*60*24; end;");
       Bind (Stmt,Numb,":result");
--      Bind (Stmt,Strv,":result");
      Set_Value (Numb, To_Number (4.0));
      Bind (Stmt,Date,":client_time");
      Set_Value (Date,Sysdate); -- client local time
      Put_Line ("Client time : "&To_String(Get_Value(Date),"Day Ddspth Month Yyyyspth HH24:MI:SS"));
      Execute(Stmt);
      Put_Line ("Time difference : "&To_String(Get_Value(Numb),"FM999990.099")&" seconds");

      oNumb1 := Get_Value (Numb);
      oNumb2 := abs (onumb1);
      put("Time difference : ");
      Put_Line(To_String (onumb1,"FM999990.099") & " seconds");
      Put_Line(To_String (To_Number (To_Long_Float (-onumb2)), "FM9999999.099999"));
      Put_Line(To_String (onumb2, "FM999990.099"));

      onumb1 := To_Number (0.5);
      onumb2 := onumb1 + onumb2;
      onumb2 := ArcTan2 (onumb1, onumb2);
      Put_Line("Arc");
      Put_Line(To_String(onumb2,"FM999990.099"));
      Put_Line("---------------------");
      
      OCI.Thick.Debug_Allocation.Print_Info;
      Put_Line ("Memory allocation count "  
        & Integer'Image (OCI.Environments.Counter.Value) & ASCII.LF
        & "Last allocated size "
        & Integer'Image (OCI.Environments.Last_Size)
         );

      declare
         Char : Character;
      begin
         Text_IO.Put_Line ("Press a q to exit or any key to continue ...");
         Text_IO.Get_Immediate (Char);
         exit when char = 'q';
      end;

      end loop;

      exception
        when E : LIB_ERROR =>
             Put_Line(Last_Error_Message);
--        when E : others =>
--             Put_Line(Ada.Exceptions.Exception_Information(E));
   when E : others =>
      Text_IO.Put_Line(Ada.Exceptions.Exception_Information(E));
      Text_IO.Put_Line("----------");
      Text_IO.Put_Line(GNAT.Traceback.Symbolic.Symbolic_Traceback(E));
   end Main;

--   remove comments below to check multitasking
   task type Parallel is
     entry Start;
     entry Wait;
   end Parallel;

   task body Parallel is
   begin
      accept start;
      Main;
      accept Wait;
   end Parallel;

      p : array (1..0) of parallel;
---------------------------------------
begin
   Put_Line ("Start");
   OCI.Thick.Debug_Allocation.Start;
   Put_Line ("Started");
   for i in p'Range loop
      p(i).Start;
   end loop;
   Main;

   for i in p'Range loop
      p(i).Wait;
   end loop;
exception
   when E : others =>
      Text_IO.Put_Line(Ada.Exceptions.Exception_Information(E));
      Text_IO.Put_Line("----------");
      Text_IO.Put_Line(GNAT.Traceback.Symbolic.Symbolic_Traceback(E));
end Test;